/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.dicommodel.rt;

import java.io.IOException;
import java.util.Locale;


import cdac.medinfo.sdk.dcm30_04.baselibs.FractionGroupSequence;
import cdac.medinfo.sdk.dcm30_04.baselibs.FractionGroupSequenceItem;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataSet;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomStream;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IItem;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.ApprovalModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.ClinicalTrialSeriesModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.CommonInstanceReferenceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.FrameOfReferenceModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.GeneralEquipmentModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.GeneralSeriesModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.GeneralStudyModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.NonImageIOD;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.PatientModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.PatientStudyModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTBeamsModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTBrachyApplicationSetupsModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTFractionSchemeModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTGeneralPlanModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTPatientSetupModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTPrescriptionModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTSeriesModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.RTToleranceTablesModule;
import cdac.medinfo.sdk.dcm30_04.dicommodel.modules.SOPCommonModule;
import cdac.medinfo.sdk.dcm30_04.enums.EnumModuleNames;
import cdac.medinfo.sdk.dcm30_04.enums.EnumSOPClassUIDs;

import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidIODException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidModuleException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ParseException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
import cdac.medinfo.sdk.dcm30_04.utils.ICollectionIterator;
import cdac.medinfo.sdk.dcm30_04.utils.ResourceBundleWrapper;

/**
 * The focus for this Radiotherapy Plan IOD (RT Plan IOD) is to address the requirements for
 * transfer of treatment plans generated by manual entry, a virtual simulation system, or a treatment
 * planning system before or during a course of treatment. Such plans may contain fractionation
 * information, and define external beams and/or brachytherapy application setups. This IOD may
 * also contain audio curve annotations.
 */
public class RTPlanIOD extends NonImageIOD 
{
	

	/**
	 * The Constant RT_PLAN_IOD.
	 */
	public static final String RT_PLAN_IOD = "RT Plan IOD";

	/**
	 * The obj approval module.
	 */
	ApprovalModule objApprovalModule =null;

	/**
	 * The obj Common Instance Reference Module .
	 */
	CommonInstanceReferenceModule objCommonInstanceReferenceModule = null;

	/**
	 * The obj clinical trial series module.
	 */
	ClinicalTrialSeriesModule objClinicalTrialSeriesModule = null;

	/**
	 * The obj frame of reference module.
	 */
	FrameOfReferenceModule objFrameOfReferenceModule = null;

	/**
	 * The obj general equipment module.
	 */
	GeneralEquipmentModule objGeneralEquipmentModule = null;

	/**
	 * The obj general study module.
	 */
	GeneralStudyModule objGeneralStudyModule = null;

	/**
	 * The obj patient module.
	 */
	PatientModule objPatientModule = null;

	/**
	 * The obj patient study module.
	 */
	PatientStudyModule objPatientStudyModule = null;

	/**
	 * The obj rt beams module.
	 */
	RTBeamsModule objRTBeamsModule = null;

	/**
	 * The obj rt brachy application setups module.
	 */
	RTBrachyApplicationSetupsModule objRTBrachyApplicationSetupsModule = null;

	/**
	 * The obj rt fraction scheme module.
	 */
	RTFractionSchemeModule objRTFractionSchemeModule = null;

	/**
	 * The obj rt general plan module.
	 */
	RTGeneralPlanModule objRTGeneralPlanModule = null;

	/**
	 * The obj rt prescription module.
	 */
	RTPrescriptionModule objRTPrescriptionModule = null;

	/**
	 * The obj rt patient setup module.
	 */
	RTPatientSetupModule objRTPatientSetupModule = null;

	/**
	 * The obj rt series module.
	 */
	RTSeriesModule objRTSeriesModule = null;

	/**
	 * The obj rt tolerance tables module.
	 */
	RTToleranceTablesModule objRTToleranceTablesModule = null;

	/**
	 * The obj sop common module.
	 */
	SOPCommonModule objSOPCommonModule = null;

	/**
	 * Instantiates a new rT plan iod.
	 */
	public RTPlanIOD()
	{
		super();
	}

	/**
	 * This constructor initializes the TransferSyntax  in its superclass IOD.
	 * 
	 * @param objITransferSyntax_ - specifies the DICOM Standard defined TransfeSyntax.
	 */
	public RTPlanIOD(ITransferSyntax objITransferSyntax_)
	{
		super(objITransferSyntax_);
	}

	/**
	 * This constructor initializes the  DictionaryReader
	 * in its superclass IOD.
	 * 
	 * @param objIDictionaryReader_ - specifies the DICOM Dictionary reader to be used .
	 */
	public RTPlanIOD(IDictionaryReader objIDictionaryReader_)
	{
		super(objIDictionaryReader_);
	}

	/**
	 * This constructor accepts the DataSet from the user   in its superclass IOD.
	 * 
	 * @param objIDataSet_ - specifies the data set to be set in the IOD.
	 */
	public RTPlanIOD(IDataSet objIDataSet_)
	{
		super(objIDataSet_);
	}

	/**
	 * This constructor initializes the TransferSyntax and DictionaryReader in its super class IOD.
	 * 
	 * @param objITransferSyntax_ specifies the DICOM Standard defined TransfeSyntax.
	 * @param objIDictionaryReader_ specifies the DICOM Dictionary reader to be used .
	 */
	public RTPlanIOD(ITransferSyntax objITransferSyntax_,IDictionaryReader objIDictionaryReader_)
	{
		super(objITransferSyntax_,objIDictionaryReader_);
	}

	/**
	 * Creates RTPlanIOD IOD from a DICOM file containing RTPlanIOD DICOM data.
	 * @param strFileName DICOM File with absolute path.
	 * @throws IOException Exception caused due to wrong I/O operations. 
	 * @throws ParseException signals if some parse exceptions are occurred.
	 * @throws InvalidIODException signals if some IOD exceptions are occurred.
	 */
	public RTPlanIOD(String strFileName)throws IOException,InvalidIODException
	{
		super(strFileName);
		try
		{
			if(objIDataSet != null)
			{
				String strSOPClassUID = objIDataSet.getSOPClassUID();
				if(strSOPClassUID != null)
				{
					if(!strSOPClassUID.equals(EnumSOPClassUIDs.RTPLANIOD.getValue()))
					{
						throw new InvalidIODException(ResourceBundleWrapper.getValue("exceptions", "InvalidIOD.FileNotMatched", new Locale(DicomConfig.createInstance().getLocale())) + RT_PLAN_IOD);
					}
				}
				strSOPClassUID = null;
			}
		}
		catch(InvalidIODException iie)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(iie.getMessage());
			}
			throw iie;
		}
	}


	/**
	 * This method validates Non-Image IOD RTPlanIOD according to the Module Table given in The DICOM Standard.
	 * The validate method fails if one of the mandatory modules are absent or any of the
	 * modules are invalid. The validate method also checks for conditional modules.
	 * 
	 * @return boolean - status of validation as success or failure
	 * 
	 * @throws InvalidIODException -  throws when the IOD is invalid.
	 */
	public boolean validate() throws InvalidIODException
	{
		try
		{
			super.validate();

			/*Validate the mandatory elements*/
			getPatientModule().validateModule();
			getGeneralStudyModule().validateModule();
			getRTSeriesModule().validateModule();
			getGeneralEquipmentModule().validateModule();
			getRTGeneralPlanModule().validateModule();
			getSOPCommonModule().validateModule();

			/*Validate conditional modules*/
			String strNumberOfBeams = null ;
			String strNumberofBrachyApplicationSetups = null;
			RTFractionSchemeModule objRTFractionSchemeModule = getRTFractionSchemeModule();
			FractionGroupSequence objFractionGroupSequence = objRTFractionSchemeModule.getFractionGroupSequence();
			ICollectionIterator<IItem> objICollectionIterator= objFractionGroupSequence.iterator();

			while(objICollectionIterator.hasNext())
			{
				IItem objIItem = objICollectionIterator.next() ;
				if(objIItem != null)
				{
					FractionGroupSequenceItem objFractionGroupSequenceItem = (FractionGroupSequenceItem)objIItem ;
					strNumberOfBeams = objFractionGroupSequenceItem.getNumberOfBeams();
					strNumberofBrachyApplicationSetups = objFractionGroupSequenceItem.getNumberOfBrachyApplicationSetups();
					break;
				}

			}
			int iNumberOfBeams = Integer.parseInt(strNumberOfBeams);
			int iNumberofBrachyApplicationSetups = Integer.parseInt(strNumberofBrachyApplicationSetups);

			if(isModulePresent(RTFractionSchemeModule.objSingleCollection,objIDataSet) && iNumberOfBeams >0 && !(isModulePresent(RTBeamsModule.objSingleCollection,objIDataSet)))
				throw new InvalidIODException("RT Beam Required if RT Fraction Scheme Module exists and Number of Beams (300A,0080) is greater than zero for one or more fraction groups");
			if(isModulePresent(RTFractionSchemeModule.objSingleCollection,objIDataSet) && iNumberofBrachyApplicationSetups >0 && !(isModulePresent(RTBrachyApplicationSetupsModule.objSingleCollection,objIDataSet)))
				throw new InvalidIODException("RT Brachy Application Setups Required if RT Fraction Scheme Module exists and Number of Brachy Application Setups (300A,00A0) is greater than zero for one or more fraction groups");

			/*Validate optional modules*/
			if(isModulePresent(PatientStudyModule.objSingleCollection,objIDataSet))
				getPatientStudyModule().validateModule();

			if(isModulePresent(ClinicalTrialSeriesModule.objSingleCollection,objIDataSet))
				getClinicalTrialSeriesModule().validateModule();

			if(isModulePresent(FrameOfReferenceModule.objSingleCollection,objIDataSet))
				getFrameOfReferenceModule().validateModule();

			if(isModulePresent(RTPrescriptionModule.objSingleCollection,objIDataSet))
				getRTPrescriptionModule().validateModule();

			if(isModulePresent(RTToleranceTablesModule.objSingleCollection,objIDataSet))
				getRTToleranceTablesModule().validateModule();

			if(isModulePresent(RTPatientSetupModule.objSingleCollection,objIDataSet))
				getRTPatientSetupModule().validateModule();

			if(isModulePresent(RTFractionSchemeModule.objSingleCollection,objIDataSet))
				getRTFractionSchemeModule().validateModule();

			if(isModulePresent(ApprovalModule.objSingleCollection,objIDataSet))
				getApprovalModule().validateModule();

			if(isModulePresent(CommonInstanceReferenceModule.objSingleCollection, objIDataSet))
				getCommonInstanceReferenceModule().validateModule();

		}
		catch(InvalidModuleException ime)
		{
			if(DicomConfig.createInstance().isLoggingOn())
				DicomLogger.getLogger().log(ime.getMessage());
			
				throw new InvalidIODException(RT_PLAN_IOD,ime);
		}
		return true;
	}

	/**
	 * Retrieves pre-initialized instance of Approval Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return ApprovalModule - instance of {@link ApprovalModule}.
	 */
	public ApprovalModule getApprovalModule() 
	{
		if(objApprovalModule == null)
		{
			objApprovalModule = new ApprovalModule(objIDataSet);
			return objApprovalModule;
		}
		return objApprovalModule;
	}

	/**
	 * Retrieves pre-initialized instance of Common Instance Reference Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return - instance of {@link CommonInstanceReferenceModule}.
	 */
	public CommonInstanceReferenceModule getCommonInstanceReferenceModule() 
	{
		if(objCommonInstanceReferenceModule == null)
		{
			objCommonInstanceReferenceModule = new CommonInstanceReferenceModule(objIDataSet);
			return objCommonInstanceReferenceModule;
		}
		return objCommonInstanceReferenceModule;
	}

	/**
	 * Retrieves pre-initialized instance of Clinical Trial Series Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return ClinicalTrialSeriesModule - instance of {@link ClinicalTrialSeriesModule}.
	 */
	public ClinicalTrialSeriesModule getClinicalTrialSeriesModule() 
	{
		if(objClinicalTrialSeriesModule == null)
		{
			objClinicalTrialSeriesModule = new ClinicalTrialSeriesModule(objIDataSet);
			return objClinicalTrialSeriesModule;
		}
		return objClinicalTrialSeriesModule;
	}



	/**
	 * Retrieves pre-initialized instance of General Equipment Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return GeneralEquipmentModule - instance of {@link GeneralEquipmentModule}.
	 */
	public GeneralEquipmentModule getGeneralEquipmentModule()
	{
		if(objGeneralEquipmentModule == null)
		{
			objGeneralEquipmentModule = new GeneralEquipmentModule(objIDataSet);
			return objGeneralEquipmentModule;
		}
		return objGeneralEquipmentModule;
	}

	/**
	 * Retrieves pre-initialized instance of General Study Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return GeneralStudyModule - instance of {@link GeneralStudyModule}.
	 */
	public GeneralStudyModule getGeneralStudyModule() 
	{
		if(objGeneralStudyModule == null)
		{
			objGeneralStudyModule = new GeneralStudyModule(objIDataSet);
			return objGeneralStudyModule;
		}
		return objGeneralStudyModule;
	}

	/**
	 * Retrieves pre-initialized instance of Patient Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return PatientModule - instance of {@link PatientModule}.
	 */
	public PatientModule getPatientModule() 
	{
		if(objPatientModule == null)
		{
			objPatientModule = new PatientModule(objIDataSet);
			return objPatientModule;
		}
		return objPatientModule;
	}

	/**
	 * Retrieves pre-initialized instance of Patient Study Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return PatientStudyModule - instance of {@link PatientStudyModule}.
	 */
	public PatientStudyModule getPatientStudyModule()
	{
		if(objPatientStudyModule == null)
		{
			objPatientStudyModule = new PatientStudyModule(objIDataSet);
			return objPatientStudyModule;
		}
		return objPatientStudyModule;
	}

	/**
	 * Retrieves pre-initialized instance of SOP Common Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return SOPCommonModule - instance of {@link SOPCommonModule}.
	 */
	public SOPCommonModule getSOPCommonModule() 
	{
		if(objSOPCommonModule == null)
		{
			objSOPCommonModule = new SOPCommonModule(objIDataSet);
			return objSOPCommonModule;
		}
		return objSOPCommonModule;
	}

	/**
	 * Retrieves pre-initialized instance of RT Series Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTSeriesModule - instance of {@link RTSeriesModule}.
	 */
	public RTSeriesModule getRTSeriesModule() 
	{
		if(objRTSeriesModule == null)
		{
			objRTSeriesModule = new RTSeriesModule(objIDataSet);
			return objRTSeriesModule;
		}
		return objRTSeriesModule;
	}

	/**
	 * Retrieves pre-initialized instance of Frame Of Reference Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return FrameOfReferenceModule - instance of {@link FrameOfReferenceModule}.
	 */
	public FrameOfReferenceModule getFrameOfReferenceModule() 
	{
		if(objFrameOfReferenceModule == null)
		{
			objFrameOfReferenceModule = new FrameOfReferenceModule(objIDataSet);
			return objFrameOfReferenceModule;
		}
		return objFrameOfReferenceModule;
	}

	/**
	 * Retrieves pre-initialized instance of RT General Plan Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTGeneralPlanModule - instance of {@link RTGeneralPlanModule}.
	 */
	public RTGeneralPlanModule getRTGeneralPlanModule() 
	{
		if(objRTGeneralPlanModule == null)
		{
			objRTGeneralPlanModule = new RTGeneralPlanModule(objIDataSet);
			return objRTGeneralPlanModule;
		}
		return objRTGeneralPlanModule;
	}

	/**
	 * Retrieves pre-initialized instance of RT Prescription Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTPrescriptionModule - instance of {@link RTPrescriptionModule}.
	 */
	public RTPrescriptionModule getRTPrescriptionModule() 
	{
		if(objRTPrescriptionModule  == null)
		{
			objRTPrescriptionModule  = new RTPrescriptionModule(objIDataSet);
			return objRTPrescriptionModule ;
		}
		return objRTPrescriptionModule ;
	}

	/**
	 * Retrieves pre-initialized instance of RT Tolerance Tables Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTToleranceTablesModule - instance of {@link RTToleranceTablesModule}.
	 */
	public RTToleranceTablesModule getRTToleranceTablesModule() 
	{
		if(objRTToleranceTablesModule  == null)
		{
			objRTToleranceTablesModule  = new RTToleranceTablesModule(objIDataSet);
			return objRTToleranceTablesModule ;
		}
		return objRTToleranceTablesModule ;
	}

	/**
	 * Retrieves pre-initialized instance of RT Patient Setup Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTPatientSetupModule - instance of {@link RTPatientSetupModule}.
	 */
	public RTPatientSetupModule  getRTPatientSetupModule () 
	{
		if(objRTPatientSetupModule   == null)
		{
			objRTPatientSetupModule  = new RTPatientSetupModule(objIDataSet);
			return objRTPatientSetupModule ;
		}
		return objRTPatientSetupModule ;
	}

	/**
	 * Retrieves pre-initialized instance of RT Fraction Scheme Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTFractionSchemeModule - instance of {@link RTFractionSchemeModule}.
	 */
	public RTFractionSchemeModule getRTFractionSchemeModule() 
	{
		if(objRTFractionSchemeModule == null)
		{
			objRTFractionSchemeModule  = new RTFractionSchemeModule(objIDataSet);
			return objRTFractionSchemeModule ;
		}
		return objRTFractionSchemeModule ;
	}

	/**
	 * Retrieves pre-initialized instance of RT Beams Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTBeamsModule - instance of {@link RTBeamsModule}.
	 */
	public RTBeamsModule getRTBeamsModule() 
	{
		if(objRTBeamsModule == null)
		{
			objRTBeamsModule  = new RTBeamsModule(objIDataSet);
			return objRTBeamsModule ;
		}
		return objRTBeamsModule ;
	}

	/**
	 * Retrieves pre-initialized instance of RT Brachy Application Setups Module. Creates a new instance
	 * if no pre-existing module instance is available.If previously created instance is
	 * present then returns the same module instance.
	 * 
	 * @return RTBrachyApplicationSetupsModule - instance of {@link RTBrachyApplicationSetupsModule}.
	 */
	public RTBrachyApplicationSetupsModule  getRTBrachyApplicationSetupsModule() 
	{
		if(objRTBrachyApplicationSetupsModule == null)
		{
			objRTBrachyApplicationSetupsModule  = new RTBrachyApplicationSetupsModule(objIDataSet);
			return objRTBrachyApplicationSetupsModule ;
		}
		return objRTBrachyApplicationSetupsModule ;
	}

	/**
	 *  Dumps the Name of IOD,Module and corresponding Attributs of Module.
	 *  @param objIDicomStream - the Stream on which the Data is to be written.
	 *  @throws IOException - Exception is thrown indicating runtime failure of writing operation.
	 */
	public void dumpDICOMInfo(IDicomStream objIDicomStream) throws IOException
	{
		objIDicomStream.writeString(RT_PLAN_IOD + "\n");
		super.dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getApprovalModule().getClass().getSimpleName() + "\n");
		getApprovalModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getCommonInstanceReferenceModule().getClass().getSimpleName() + "\n");
		getCommonInstanceReferenceModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getClinicalTrialSeriesModule().getClass().getSimpleName() + "\n");
		getClinicalTrialSeriesModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getFrameOfReferenceModule().getClass().getSimpleName() + "\n");
		getFrameOfReferenceModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getGeneralEquipmentModule().getClass().getSimpleName() + "\n");
		getGeneralEquipmentModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getGeneralStudyModule().getClass().getSimpleName() + "\n");
		getGeneralStudyModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getPatientModule().getClass().getSimpleName() + "\n");
		getPatientModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getPatientStudyModule().getClass().getSimpleName() + "\n");
		getPatientStudyModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTBeamsModule().getClass().getSimpleName() + "\n");
		getRTBeamsModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTBrachyApplicationSetupsModule().getClass().getSimpleName() + "\n");
		getRTBrachyApplicationSetupsModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTFractionSchemeModule().getClass().getSimpleName() + "\n");
		getRTFractionSchemeModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTGeneralPlanModule().getClass().getSimpleName() + "\n");
		getRTGeneralPlanModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTPrescriptionModule().getClass().getSimpleName() + "\n");
		getRTPrescriptionModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTPatientSetupModule().getClass().getSimpleName() + "\n");
		getRTPatientSetupModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTSeriesModule().getClass().getSimpleName() + "\n");
		getRTSeriesModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getRTToleranceTablesModule().getClass().getSimpleName() + "\n");
		getRTToleranceTablesModule().dumpDICOMInfo(objIDicomStream);

		objIDicomStream.writeString("\t" + getSOPCommonModule().getClass().getSimpleName() + "\n");
		getSOPCommonModule().dumpDICOMInfo(objIDicomStream);
	}

	/**
	 * Checks whether the Module is present in the IOD or not.
	 * @param strModuleName String value of module name 
	 * @return boolean - true if the module is present in the IOD, else false is returned.
	 */
	public boolean isModulePresent(String strModuleName)
	{
		if(!super.isModulePresent(strModuleName))
		{
			if(strModuleName == null || strModuleName.equals(""))
				return false;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.APPROVAL_MODULE.getValue()) && isModulePresent(ApprovalModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.CLINICAL_TRIAL_SERIES_MODULE.getValue()) && isModulePresent(ClinicalTrialSeriesModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.GENERAL_EQUIPMENT_MODULE.getValue()) && isModulePresent(GeneralEquipmentModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.GENERAL_SERIES_MODULE.getValue()) && isModulePresent(GeneralSeriesModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.GENERAL_STUDY_MODULE.getValue()) && isModulePresent(GeneralStudyModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.PATIENT_MODULE.getValue()) && isModulePresent(PatientModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.PATIENT_STUDY_MODULE.getValue()) && isModulePresent(PatientStudyModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_BEAMS_MODULE.getValue()) && isModulePresent(RTBeamsModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_BRACHY_APPLICATION_SETUPS_MODULE.getValue()) && isModulePresent(RTBrachyApplicationSetupsModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_FRACTION_SCHEME_MODULE.getValue()) && isModulePresent(RTFractionSchemeModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_GENERAL_PLAN_MODULE.getValue()) && isModulePresent(RTGeneralPlanModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_PRESCRIPTION_MODULE.getValue()) && isModulePresent(RTPrescriptionModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_PATIENT_SETUP_MODULE.getValue()) && isModulePresent(RTPatientSetupModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_SERIES_MODULE.getValue()) && isModulePresent(RTSeriesModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.RT_TOLERANCE_TABLES_MODULE.getValue()) && isModulePresent(RTToleranceTablesModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.SOP_COMMON_MODULE.getValue()) && isModulePresent(SOPCommonModule.objSingleCollection))
				return true;
			else if(strModuleName.equalsIgnoreCase(EnumModuleNames.COMMON_INSTANCE_REFERENCE_MODULE.getValue()) && isModulePresent(CommonInstanceReferenceModule.objSingleCollection))
				return true;
			else
			{
				if(DicomConfig.createInstance().isLoggingOn())
				{
					DicomLogger objDicomLogger = DicomLogger.getLogger();
					objDicomLogger.log(this.getClass().getName() + " : " +ResourceBundleWrapper.getValue("status","ModuleNotPresent",new Locale(DicomConfig.createInstance().getLocale())) + strModuleName);
				}
				return false;
			}
		}
		return true;
	}
}
